--| 03/10/2012
--| 
--| ENUNCIADO:
--| Ahora se trata de que el programa sea quien controle el momento de
--| activacin de las tareas. Es decir, se va a ejecutar la tarea que el
--| programa vaya indicando (por cdigo o se podra hacer que se le pidiera
--| al usuario qu quiere activar). Crea tres tareas que sean instancia de
--| una tarea tipo definida previamente (sin parmetros en este caso) y
--| haz que acepten una cita identificacin (con un parmetro que valdr
--| 1, 2,  3 segn la tarea de que se trate para facilitar la escritura
--| del mensaje) que suponga la ejecucin del cdigo asociado a una tarea
--| u otra (es decir, salga el mensaje correspondiente por pantalla).

--| CONCLUSION:
--|Ahora podemos elegir en que comento del programa queremos llamar a la
--|tarea mediante el uso de citas. Cuando llamamos a la tarea se ejecuta,
--|aparentemente, de principio a fin sin interrupciones, asi tarea tras
--|tarea que llamamos.

--| EJECUCION:
--| Soy 1
--| Soy 1
--| Soy 1
--| Soy 1
--| Soy 1
--| Soy 1
--| Soy 1
--| Soy 1
--| Soy 1
--| Soy 1
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 2
--| Soy 3
--| Soy 3
--| Soy 3
--| Soy 3


with Ada.Text_IO;


procedure ada1x04 is

	use Ada.Text_IO;

	
	-- Se especifica un tipo tarea con una cita:
	task type tarea is
		entry cita(char:Character ; rep:Integer);
	end tarea;
	
	
	--| Se implementa la tarea:
	task body tarea is
	begin
		accept cita(char:Character ; rep:Integer) do
			for i in 1..rep loop
				put("Soy "); put(char); new_line;
				delay 0.01;
			end loop;
		end cita;
	end tarea;
	
	-- Se instancian las tareas:
	t1:tarea;
	t2:tarea;
	t3:tarea;
	
begin

	-- Se llama a la cita de las tareas de forma parametrizada:
	t1.cita('1',10);
	t2.cita('2',15);
	t3.cita('3', 4);

--	for c in 1..7 loop
--		put_line("Soy P");
--		delay 0.01;
--	end loop;
		
end ada1x04;
