--| 10/10/2012
--| ESPECIFICACIN



with
 Text_IO,
 Ada.Integer_Text_IO,
 random,
 Sequential_IO;
  
use
 Text_IO,
 Ada.Integer_Text_IO;


	
generic

	-- Parametros recibidos en la instanciacion del paquete:
	filas    : positive;
	columnas : positive;


package matrices_con_tareas is


	-- Se instancia el paquete para el uso de ficheros uniforme solo de numeros enteros:
	package f is new Sequential_IO(Integer);
	use f;
	

	-- Tipo Matriz:
	type Matriz is array( positive range<>, positive range<> ) of Integer;
	
	
	-- Especificacion del tipo Tarea
	task type Tarea is
		entry calcular( mA:Matriz ; mB:Matriz ; i:Positive ; j:Positive ; mR:out Matriz );
	end tarea;
	
	
	-- Puntero a Tipo tarea:
	type pTarea is access Tarea;
		
		
	-- Funciones y procedimientos:
	function	"*"(mA:in Matriz ; mB:in Matriz) return Matriz;
	function	randomInteger(max:in Integer) return Integer;
	procedure	createFileOfRandomNumbers( filMA:Positive ; colMA:Positive ; colMB:Positive ; numMax:Positive );
	procedure	readFileOfRandomNumbers( mA:Out Matriz ; mB:Out Matriz );
	procedure   put( m:in Matriz );
	
		
	private
	
end matrices_con_tareas;
